<ng-container *ngTemplateOutlet="tokenSection"></ng-container>

@switch (currentLayout$ | async) {
  @case (Layout.LOADING) {
    <ng-container *ngTemplateOutlet="loading"></ng-container>
  }
  @case (Layout.ERROR) {
    <ng-container *ngTemplateOutlet="errorMessage"></ng-container>
  }
  @case (Layout.NO_CREDENTIALS) {
    <ng-container *ngTemplateOutlet="noCredentialsMessage"></ng-container>
  }
  @case (Layout.READY) {
    <ng-container *ngTemplateOutlet="mainPanel"></ng-container>
  }
}

<ng-template #tokenSection>
  @if (state$ | async; as state) {
    <div class="two-cols-grid center-items">
      @if (isTokenFieldVisible$ | async) {
        <div class="flex-row">
          <sqtm-core-label
            [text]="
              'sqtm-core.administration-workspace.bugtrackers.authentication-policy.credentials.token'
                | translate
            "
          >
          </sqtm-core-label>
          <i
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="outline"
            nz-tooltip
            [nzTooltipTitle]="tokenTooltip$ | async | translate"
            class="current-workspace-button m-l-5 table-icon-size"
          >
          </i>
        </div>
        <div class="flex-row">
          <sqtm-core-editable-text-field
            class="token-field"
            #tokenField
            [isObfuscated]="true"
            [layout]="'compact'"
            (confirmEvent)="handleTokenConfirm($event)"
            [attr.data-test-element-id]="'token-field'"
          >
          </sqtm-core-editable-text-field>
          @if (isResetTokenButtonVisible$ | async) {
            <i
              class="table-icon-size reset-tags-button __hover_pointer"
              nz-icon
              nzType="sqtm-core-administration:synchronize"
              nzTheme="outline"
              nz-tooltip
              [nzTooltipTitle]="
                'sqtm-core.administration-workspace.views.project.automation.environments.clear-token-tooltip'
                  | translate
              "
              [attr.data-test-toolbar-button-id]="'reset-token-button'"
              (click)="handleClearTokenButtonClicked($event)"
            >
            </i>
          }
        </div>
        @if (isTokenModificationWarningVisible(state$ | async)) {
          <div class="full-row m-t-0">
            <span style="color: red">{{
              I18nKeys.CHANGE_TOKEN_WARNING | translate
            }}</span>
          </div>
        }
      }
      @if (true) {
        <div class="flex-row">
          <sqtm-core-label [text]="environmentTagsLabel"></sqtm-core-label>
          @if (selectInputTooltip) {
            <i
              nz-icon
              nzType="sqtm-core-generic:help"
              nzTheme="outline"
              nz-tooltip
              [nzTooltipTitle]="selectInputTooltip"
              class="current-workspace-button m-l-5 table-icon-size"
            >
            </i>
          }
        </div>
        <div class="flex-row">
          <sqtm-core-editable-tag-list-field
            class="flex-grow-shrink"
            [value]="state.selectedTags"
            [options]="state.availableEnvironmentTags"
            [disabled]="isTagInputDisabled$ | async"
            (nzFocus)="handleTagsFieldFocus()"
            (confirmEvent)="updateEnvironmentTags($event)"
            [attr.data-test-element-id]="'selected-environment-tags'"
          >
          </sqtm-core-editable-tag-list-field>
          @if (isResetTagsButtonVisible$ | async) {
            <i
              class="table-icon-size reset-tags-button __hover_pointer"
              nz-icon
              nzType="sqtm-core-administration:synchronize"
              nzTheme="outline"
              nz-tooltip
              [nzTooltipTitle]="
                'sqtm-core.administration-workspace.views.project.automation.reset-default-env-tags'
                  | translate
              "
              [attr.data-test-toolbar-button-id]="'reset-tags-button'"
              (click)="handleResetButtonClicked($event)"
            >
            </i>
          }
        </div>
      }
    </div>
  }
</ng-template>

<ng-template #mainPanel>
  <div class="m-t-15">
    <div
      class="m-10 __hover_pointer flex space-between"
      (click)="toggleAvailableEnvironmentsPanelVisibility()"
    >
      <div>
        @if (isAvailableEnvironmentsPanelExpanded) {
          <i nz-icon nzType="caret-down" nzTheme="fill"></i>
        } @else {
          <i nz-icon nzType="caret-right" nzTheme="fill"></i>
        }
        <span class="collapse-header m-l-10">{{
          I18nKeys.AVAILABLE_ENVIRONMENTS | translate
        }}</span>
      </div>
      <i
        nz-icon
        nzType="sqtm-core-generic:refresh"
        nzTheme="outline"
        class="current-workspace-button tree-icon-size reset-tags-button m-r-35"
        nz-tooltip
        [nzTooltipTitle]="'sqtm-core.generic.label.refresh' | translate"
        [attr.data-test-toolbar-button-id]="'refresh-button'"
        (click)="refreshExecutionEnvironments()"
      >
      </i>
    </div>
    @if (isAvailableEnvironmentsPanelExpanded) {
      @if (noMatchingEnvironments$ | async) {
        @if (tagHolderType !== 'EXECUTION_DIALOG') {
          <span [attr.data-test-element-id]="'no-matching-environment'">
            {{ I18nKeys.NO_MATCHING_ENVIRONMENT | translate }}
          </span>
        } @else {
          <span
            class="error-message"
            [attr.data-test-element-id]="
              'no-matching-environment-execution-dialog'
            "
          >
            {{
              I18nKeys.NO_MATCHING_ENVIRONMENT_IN_EXECUTION_DIALOG | translate
            }}
          </span>
        }
      } @else {
        <sqtm-core-grid></sqtm-core-grid>
      }
    }
  </div>
</ng-template>

<ng-template #noCredentialsMessage>
  @if (isProjectMissingCredentialsMessage() | async) {
    <div class="flex-row" style="align-items: center">
      <i
        nz-icon
        class="sqtm-core-icon"
        nzType="info-circle"
        nzTheme="twotone"
        [nzTwotoneColor]="'#FFCC00'"
      ></i>
      <b [attr.data-test-element-id]="'missing-credentials-message'">
        {{ missingCredentialsMessage$ | async | translate }}
      </b>
    </div>
  } @else {
    <span [attr.data-test-element-id]="'missing-credentials-message'">
      {{ missingCredentialsMessage$ | async | translate }}
    </span>
  }
</ng-template>

<ng-template #loading>
  <div class="full-height full-width">
    <sqtm-core-full-page-loading-icon></sqtm-core-full-page-loading-icon>
  </div>
</ng-template>

<ng-template #errorMessage>
  <span
    class="error-message"
    [attr.data-test-element-id]="'load-environments-error-message'"
  >
    {{ getErrorMessage() | async | translate }}
  </span>
</ng-template>
